//
// Created by robin on 10/1/17.
//

#ifndef MIFARE_TOOLS_LIBNFCOPERATION_HXX
#define MIFARE_TOOLS_LIBNFCOPERATION_HXX

#include "LibNfcOperation.h"

template<typename T>
void LibNfcOperation::runOperation(QSharedPointer<LibNfcBusiness> libNfc,
                          std::function<Result<T>(QSharedPointer<LibNfcBusiness>)> operation,
                          std::function<void(Result<T>)> callback)
{
    Result<T>* result = new Result<T>();
    auto nfcOperation = new LibNfcOperation(libNfc, [result, operation](QSharedPointer<LibNfcBusiness> libNfc)
    {
        auto res = operation(libNfc);
        *result = res;
    });
    connect(nfcOperation, &LibNfcOperation::finished, [result, nfcOperation, callback]()
    {
        nfcOperation->deleteLater();
        callback(*result);
        delete result;
    });
    nfcOperation->start();
}

#endif //MIFARE_TOOLS_LIBNFCOPERATION_HXX
